Subject: Re: [RFC PATCH 2/2] builtin/receive-pack: add option to skip connectivity check

From: Junio C Hamano <[email-masked]>
Date: Wed, 07 May 2025 10:20:15 -0700

Patrick Steinhardt <[email-masked]> writes:

> On Tue, May 06, 2025 at 10:02:49PM -0500, Justin Tobler wrote:
>> During git-receive-pack(1), connectivity of the object graph is
>> validated to ensure that the received packfile does not leave the
>> repository in a broken state.
>> 
>> Generally, this check is critical to avoid an incomplete receieved
>
> s/receieved/received/
>
>> packfile from corrupting a repository. In situations where server
>> operators validate the connectivity of incoming objects outside of Git,
>> such a check may be redundant.
>
> This is a bit handwavy. _I_ know why we at GitLab are doing this, but
> other readers won't have the necessary context to be able to judge
> whether this really is a good idea. I think the important question to
> answer is: why does the server side want to perform the check if Git
> already does it anyway? Why is it in a better position to do so? And why
> can't we instead have Git itself perform it in the same "better" way?

All of these would be interesting questions to be answered also in
the documentation patch (yet to come, I presume) that warns against
use of this new option by mere mortals without thinking things
through.  "Unless your receiving end has such and such facility to
ensure that new data taken from the pack stream really makes the
objects at the new tips of refs being proposed by this incoming "git
push", you'll risk corrupting your repository" or something.

Otherwise, I think the cover letter sells the "feature" nicely and
in a convincing way.

Thanks.